<?php
/**
 * @package JROX Affiliate
 * @version 1.0
 */
/*

Plugin Name: JROX Affiliate Manager for WooCommerce
Plugin URI: http://jam.jrox.com
Description: If you want a robust affiliate marketing system for Woocommerce, JROX Affiliate Manager will integrate smoothly with WooCommerce.
Author: JROX.COM
Version: 1.1
Author URI: http://jam.jrox.com
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {	

	add_action( 'woocommerce_checkout_order_processed', 'jrox_api_autoregister' );

	add_action( 'woocommerce_thankyou', 'jrox_generate_commission' );

	add_action('admin_menu', 'jrox_affiliate_settings'); 

	add_action('wp_login', 'jrox_api_autologin', 10, 2);

	// ------------------------------------------------------------------------	

	function jrox_api_autologin($user_login = '', $user = '')
	{
		if (get_option('jrox_woo_autologin') == '0') return;

		$url = get_option('jrox_woo_aff_url') . '/automate/login/'; //NO TRAILING SLASH 
		
		$access_key = get_option('jrox_woo_aff_key'); 

		$access_id = get_option('jrox_woo_aff_id');

		$sdata = array(

					   'access_key' => $access_key,
					   'access_id' => $access_id,
					   'ip' => $_SERVER['REMOTE_ADDR'],
					   'user_agent' => $_SERVER['HTTP_USER_AGENT'],
					   'email' => $user->data->user_email,
					   'bypass_pwd' => 1,
					   );		

		$fields = "";

		foreach( $sdata as $key => $value ) $fields .= "$key=" . urlencode( $value ) . "&";	

		$resp = jrox_connect_curl($url, $fields);		

		$result = json_decode( $resp);

		$jam_cookie = $result->msg;

		$secure  = $_SERVER['SERVER_PORT'] == '443' ? 1 : 0;

		if (setcookie(
					$jam_cookie->name,
					$jam_cookie->value,
					$jam_cookie->expire,
					$jam_cookie->path,
					$jam_cookie->domain,
					$secure
					))
		{
			//echo 'SUCCESS: User logged in';	
		}		
	}	

	// ------------------------------------------------------------------------

   	function jrox_api_autoregister($id = '')
	{
		if (get_option('jrox_woo_autoreg') == '0') return;	

		$url = get_option('jrox_woo_aff_url') . '/automate/register/'; //NO TRAILING SLASH 
		
		$access_key = get_option('jrox_woo_aff_key'); 

		$access_id = get_option('jrox_woo_aff_id');

		$sdata = array(
			   'access_key' => $access_key,
			   'access_id' => $access_id,
			   'email' => $_POST['billing_email'],
			   'fname' => $_POST['billing_first_name'],
			   'lname' => $_POST['billing_last_name'],
			   'billing_address_1' => $_POST['billing_address_1'],
			   'billing_city' => $_POST['billing_city'],
			   'billing_postal_code' => $_POST['billing_postcode'],
			   'username' => $_POST['account_username'],
			   'password' =>  $_POST['account_password'],
			   //'status' => 'inactive', 
			   'login_status' => 'confirmed',
			   'encrypted' => false,
			   'program_id' => '1',
			   'affiliate_group' => '1',
			   'sponsor' => !empty($_COOKIE['jamcom']) ? $_COOKIE['jamcom'] : '',
			   );

		$fields = "";

		foreach( $sdata as $key => $value ) $fields .= "$key=" . urlencode( $value ) . "&";

		$resp = jrox_connect_curl($url, $fields);		
	}

	// ------------------------------------------------------------------------

	function jrox_generate_commission($id = '')
	{
		global $wpdb;	

		$query = "SELECT * FROM {$wpdb->prefix}postmeta WHERE post_id = '" . $id . "'";

		$meta = $wpdb->get_results($query);
		
		$total = '0';
		$lf_data = '';
		$fname = '';
		$lname = '';
		$cost = '0';
				

		foreach ($meta as $v)
		{

			if ($v->meta_key == '_order_total')  $total =  $v->meta_value;

			elseif ($v->meta_key == '_billing_email') $lf_data = $v->meta_value;

			elseif ($v->meta_key == '_order_shipping') $cost += $v->meta_value;

			elseif ($v->meta_key == '_order_shipping_tax') $cost += $v->meta_value;

			elseif ($v->meta_key == '_order_tax') $cost += $v->meta_value;

			elseif ($v->meta_key == '_billing_first_name') $fname = $v->meta_value;

			elseif ($v->meta_key == '_billing_last_name') $lname = $v->meta_value;

		}

		//get per product commissions
		$query = "SELECT * 
					FROM {$wpdb->prefix}woocommerce_order_items 
					LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta
					ON {$wpdb->prefix}woocommerce_order_itemmeta.order_item_id = {$wpdb->prefix}woocommerce_order_items.order_item_id
					WHERE order_id = '" . $id . "' AND order_item_type = 'line_item'";

		$item = $wpdb->get_results($query);

		$order_item_ids = array();
		$items = array();
		foreach ($item as $i)
		{
			if (!in_array($i->order_item_id, $order_item_ids))
			{
				array_push($order_item_ids,$i->order_item_id);
			}
		}
		
		foreach ($order_item_ids as $a)
		{
			foreach ($item as $i)
			{	
				if ($i->meta_key == '_product_id' && $i->order_item_id == $a)
				{
					$items[$a]['product_id'] = $i->meta_value;
					
					//get sku
					$query = "SELECT * FROM {$wpdb->prefix}postmeta WHERE post_id = '" . $i->meta_value . "' 
								AND meta_key = '_sku'";

					$sku = $wpdb->get_results($query);
					foreach ($sku as $s)
					{
						if ($s->meta_key == '_sku')
						{
							$items[$a]['sku'] = $s->meta_value;	
						}
					}	
				}
				
				if ($i->meta_key == '_line_subtotal' && $i->order_item_id == $a)
				{
					$items[$a]['subtotal'] = $i->meta_value;
				}
				
			}
		}
		
		 //check for a coupon code
		   
		$coupon = $wpdb->get_var($wpdb->prepare("SELECT order_item_name 
							FROM {$wpdb->prefix}woocommerce_order_items 
							WHERE order_id = %d
							AND order_item_type = %s", $id, 'coupon'));
			
		if (get_option('jrox_per_product_comms') == 1)
		{
			if (!empty($items))
			{
				foreach ($items as $i)
				{
					$url =  get_option('jrox_woo_aff_url') . '/sale/index/amount/' . $i['subtotal'] . '/trans_id/' . $id . '-' . $i['product_id'] . '-' . $i['sku'] . '/lf_data/' . $lf_data . '/customer_name/' . $fname . '_' . $lname . '/tracking_code/' . $_COOKIE['jamcom'] . '/coupon_code/' . $coupon . '/product_identifier/' . $i['sku'] ;
			
					if (function_exists(file_get_contents))
					{
						file_get_contents($url);
					}
					else
					{
						jrox_connect_curl($url);
					}
				}
			}
		}
		else 
		{ 
			
			$order_total = $total - ($cost);
	
			$url =  get_option('jrox_woo_aff_url') . '/sale/index/amount/' . $order_total . '/trans_id/' . $id . '/lf_data/' . $lf_data . '/customer_name/' . $fname . '_' . $lname . '/tracking_code/' . $_COOKIE['jamcom'] . '/coupon_code/' . $coupon;
	
			if (function_exists(file_get_contents))
			{
				file_get_contents($url);
			}
			else
			{
				jrox_connect_curl($url);
			}
		}

	}

	

	// ------------------------------------------------------------------------



	function jrox_affiliate_settings() 
	{	
		add_menu_page('JROX Affiliate Settings', 'JROX Affiliate', 'administrator', 'jrox_settings', 'jrox_display_settings');

	}

	

	// ------------------------------------------------------------------------

	

	function jrox_display_settings()
	{
		$jrox_woo_aff_url = (get_option('jrox_woo_aff_url') != '') ? get_option('jrox_woo_aff_url') : 'http://jam.jrox.com';

		$jrox_woo_aff_key = (get_option('jrox_woo_aff_key') != '') ? get_option('jrox_woo_aff_key') : '';

		$jrox_woo_aff_id = (get_option('jrox_woo_aff_id') != '') ? get_option('jrox_woo_aff_id') : '';
		
		$jrox_per_product_comms1 =  (get_option('jrox_per_product_comms') == '1') ? 'selected' : '';
		
		$jrox_per_product_comms0 =  (get_option('jrox_per_product_comms') == '0') ? 'selected' : '';

		$jrox_woo_autoreg_1 = (get_option('jrox_woo_autoreg') == '1') ? 'selected' : '';

		$jrox_woo_autoreg_0 = (get_option('jrox_woo_autoreg') == '0') ? 'selected' : '';

		$jrox_woo_autologin_1 = (get_option('jrox_woo_autologin') == '1') ? 'selected' : '';

		$jrox_woo_autologin_0 = (get_option('jrox_woo_autologin') == '0') ? 'selected' : '';

		

		$html = '<div id="viewWrapper" class="view_wrapper"><div class="wrap">

            <form method="post" name="options" action="options.php">

			<div class="title_line" style="border: 1px solid #ddd; background-color: #fff; padding: 0 18px;">

            <h3>JROX Affiliate Manager Integration with WooCommerce</h3>

			<p>JROX.COM Affiliate Manager is an Affiliate Marketing System Designed to Integrate with Woocommerce for Commission Generation. You can start your own Affiliate Marketing Program for Woocommerce by downloading JAM <a href="http://jam.jrox.com" target="_blank">here</a></p>

			' . wp_nonce_field('update-options') . '

            

			<hr />

			<table class="form-table">



                <tr>

                    <th align="left" scope="row">

                    <label>JROX Affiliate URL</label>

					</th>

					<td><input type="text" name="jrox_woo_aff_url" class="regular-text code" value="' . $jrox_woo_aff_url . '" /> <small>(the URL where you installed JAM.  Do not add a trailing slash)</small>



                    </td> 

                </tr>

				

				<tr>

                    <th align="left" scope="row">

                    <label>Automation API Key</label> </th>

					<td><input type="text" name="jrox_woo_aff_key" class="regular-text code" value="' . $jrox_woo_aff_key . '" /> 



                    </td> 

                </tr>

				<tr>

                    <th align="left" scope="row">

                    <label>Automation API Secret</label> </th>

					<td><input type="text" name="jrox_woo_aff_id" class="regular-text code" value="' . $jrox_woo_aff_id . '" />



                    </td> 

                </tr>

				<tr>

                    <th align="left" scope="row">

                    <label>Automatic User Registration</label>

					</th><td>

					<select name="jrox_woo_autoreg" >

                      <option value="0" ' . $jrox_woo_autoreg_0 . '>Disable</option>

                      <option value="1" '.$jrox_woo_autoreg_1.'>Enable</option>

                    </select>

             



                    </td> 

                </tr>

				<tr>

                    <th align="left" scope="row">

                    <label>Automatic User Login</label>

					</th><td>

					<select name="jrox_woo_autologin" >

                      <option value="0" ' . $jrox_woo_autologin_0 . '>Disable</option>

                      <option value="1" '.$jrox_woo_autologin_1.'>Enable</option>

                    </select>

                    </td> 

                </tr>
				
				<tr>

                    <th align="left" scope="row">

                    <label>Enable Per Product Commissions</label>

					</th><td>

					<select name="jrox_per_product_comms" >

                      <option value="0" ' . $jrox_per_product_comms0 . '>Disable</option>

                      <option value="1" '.$jrox_per_product_comms1.'>Enable</option>

                    </select>

                    </td> 

                </tr>

            </table>

            <p class="submit">

                <input type="hidden" name="action" value="update" />  

                <input type="hidden" name="page_options" value="jrox_woo_aff_url,jrox_woo_aff_key,jrox_woo_aff_id,jrox_woo_autoreg,jrox_woo_autologin,jrox_per_product_comms" /> 

                <input type="submit" name="Submit" class="button-primary" value="Save Changes" />

            </p>

           

			</div>

       </form> </div></div> ';

    	echo $html;

	}

	

	// ------------------------------------------------------------------------



	function jrox_connect_curl($url = '', $fields = '')

	{		

		$ch = curl_init($url);

		curl_setopt($ch, CURLOPT_HEADER, 0); // set to 0 to eliminate header info from response
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, '50');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Returns response data instead of TRUE(1)
		
		if (!empty($fields))
		{
			curl_setopt($ch, CURLOPT_POSTFIELDS, rtrim( $fields, "& " )); // use HTTP POST to send form data
		}
		
		
		$resp = curl_exec($ch); //execute post and get results

		curl_close ($ch);

		return $resp;		

	}

}





?>